{% macro init_parameters(params) %}
  // [ Parameters ]
  param_subscriber_ = std::make_shared<rclcpp::ParameterEventHandler>(this);

  {% for param in params.list %}
  ins.{{ param.name }} = this->declare_parameter<{{ param.type }}>("{{ param.name }}", {{ param.default_value }});
  {{ param.name }}_callback_handle_ = param_subscriber_->add_parameter_callback("{{ param.name }}",
    std::bind(&node::{{ param.name }}_param_callback, this, std::placeholders::_1)
  );
  {% endfor %}

  {% if params.validation is defined and params.validation %}
  global_param_cb_handle = this->add_on_set_parameters_callback(std::bind(&node::callback_on_parameters_change, this, std::placeholders::_1));
  {% endif %}
{% endmacro %}

